
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>RESTful架构详解（转） / iVAN</title>

    <meta name="description" content="RESTful架构详解（转） 1. 什么是REST REST全称是Representational State Transfer,中文意思是表述(编者注:通常译为表征)性状态转移. 它首次出现在2000年Roy Fielding的博士论文中,Roy Fielding是HTTP规范的主要编写者之一. 他在论文中提到:&quot;我这篇文章的写作目的,就是想在符合架构原理的前提下,理解和评估以网络为基础的应用软件的架构设计,得到一个功能强.性能好.适宜通信的架构.REST指的是一组架构约束条件和原则.&quot; 如果一个架构符 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">RESTful架构详解（转）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>　　<strong>1. 什么是REST</strong></p>
<p>　　REST全称是Representational State Transfer，中文意思是表述（编者注：通常译为表征）性状态转移。 它首次出现在2000年Roy Fielding的博士论文中，Roy Fielding是HTTP规范的主要编写者之一。 他在论文中提到：“我这篇文章的写作目的，就是想在符合架构原理的前提下，理解和评估以网络为基础的应用软件的架构设计，得到一个功能强、性能好、适宜通信的架构。REST指的是一组架构约束条件和原则。” 如果一个架构符合REST的约束条件和原则，我们就称它为RESTful架构。</p>
<p>　　REST本身并没有创造新的技术、组件或服务，而隐藏在RESTful背后的理念就是使用Web的现有特征和能力， 更好地使用现有Web标准中的一些准则和约束。虽然REST本身受Web技术的影响很深， 但是理论上REST架构风格并不是绑定在HTTP上，只不过目前HTTP是唯一与REST相关的实例。 所以我们这里描述的REST也是通过HTTP实现的REST。</p>
<p>　　<strong>2. 理解RESTful</strong></p>
<p>　　要理解RESTful架构，需要理解Representational State Transfer这个词组到底是什么意思，它的每一个词都有些什么涵义。 下面我们结合REST原则，围绕资源展开讨论，从资源的定义、获取、表述、关联、状态变迁等角度，列举一些关键概念并加以解释。</p>
<ul>
<li>资源与URI</li>
<li>统一资源接口</li>
<li>资源的表述</li>
<li>资源的链接</li>
<li>状态的转移</li>
</ul>
<p>　　<strong>2. 1 资源与URI</strong></p>
<p>　　REST全称是表述性状态转移，那究竟指的是什么的表述? 其实指的就是资源。任何事物，只要有被引用到的必要，它就是一个资源。资源可以是实体(例如手机号码)，也可以只是一个抽象概念(例如价值) 。下面是一些资源的例子：</p>
<ul>
<li>某用户的手机号码</li>
<li>某用户的个人信息</li>
<li>最多用户订购的GPRS套餐</li>
<li>两个产品之间的依赖关系</li>
<li>某用户可以办理的优惠套餐</li>
<li>某手机号码的潜在价值</li>
</ul>
<p>　　要让一个资源可以被识别，需要有个唯一标识，在Web中这个唯一标识就是URI(Uniform Resource Identifier)。 URI既可以看成是资源的地址，也可以看成是资源的名称。如果某些信息没有使用URI来表示，那它就不能算是一个资源， 只能算是资源的一些信息而已。URI的设计应该遵循可寻址性原则，具有自描述性，需要在形式上给人以直觉上的关联。这里以github网站为例，给出一些还算不错的URI：</p>
<ul>
<li>https://github.com/git</li>
<li>https://github.com/git/git</li>
<li>https://github.com/git/git/blob/master/block-sha1/sha1.h</li>
<li>https://github.com/git/git/commit/e3af72cdafab5993d18fae056f87e1d675913d08</li>
<li>https://github.com/git/git/pulls</li>
<li>https://github.com/git/git/pulls?state=closed</li>
<li>https://github.com/git/git/compare/master…next</li>
</ul>
<p>　　下面让我们来看看URI设计上的一些技巧:</p>
<ul>
<li>使用_或-来让URI可读性更好</li>
</ul>
<p>　　曾经Web上的URI都是冰冷的数字或者无意义的字符串，但现在越来越多的网站使用_或-来分隔一些单词，让URI看上去更为人性化。 例如国内比较出名的开源中国社区，它上面的新闻地址就采用这种风格， 如http://www.oschina.net/news/38119/oschina-translate-reward-plan。</p>
<ul>
<li>使用/来表示资源的层级关系</li>
</ul>
<p>　　例如上述/git/git/commit/e3af72cdafab5993d18fae056f87e1d675913d08就表示了一个多级的资源， 指的是git用户的git项目的某次提交记录，又例如/orders/2012/10可以用来表示2012年10月的订单记录。</p>
<ul>
<li>使用?用来过滤资源</li>
</ul>
<p>　　很多人只是把?简单的当做是参数的传递，很容易造成URI过于复杂、难以理解。可以把?用于对资源的过滤， 例如/git/git/pulls用来表示git项目的所有推入请求，而/pulls?state=closed用来表示git项目中已经关闭的推入请求， 这种URL通常对应的是一些特定条件的查询结果或算法运算结果。</p>
<ul>
<li>,或;可以用来表示同级资源的关系</li>
</ul>
<p>　　有时候我们需要表示同级资源的关系时，可以使用,或;来进行分割。例如哪天github可以比较某个文件在随意两次提交记录之间的差异，或许可以使用/git/git /block-sha1/sha1.h/compare/e3af72cdafab5993d18fae056f87e1d675913d08;bd63e61bdf38e872d5215c07b264dcc16e4febca作为URI。 不过，现在github是使用…来做这个事情的，例如/git/git/compare/master…next。</p>
<p>　　<strong>2. 2 统一资源接口</strong></p>
<p>　　RESTful架构应该遵循统一接口原则，统一接口包含了一组受限的预定义的操作，不论什么样的资源，都是通过使用相同的接口进行资源的访问。接口应该使用标准的HTTP方法如GET，PUT和POST，并遵循这些方法的语义。</p>
<p>　　如果按照HTTP方法的语义来暴露资源，那么接口将会拥有安全性和幂等性的特性，例如GET和HEAD请求都是安全的， 无论请求多少次，都不会改变服务器状态。而GET、HEAD、PUT和DELETE请求都是幂等的，无论对资源操作多少次， 结果总是一样的，后面的请求并不会产生比第一次更多的影响。</p>
<p>　　下面列出了GET，DELETE，PUT和POST的典型用法:</p>
<p>　　<strong>GET</strong></p>
<ul>
<li>安全且幂等</li>
<li>获取表示</li>
<li>变更时获取表示（缓存）</li>
</ul>
<ul>
<li>200（OK） - 表示已在响应中发出</li>
</ul>
<ul>
<li>204（无内容） - 资源有空表示</li>
<li>301（Moved Permanently） - 资源的URI已被更新</li>
<li>303（See Other） - 其他（如，负载均衡）</li>
<li>304（not modified）- 资源未更改（缓存）</li>
<li>400 （bad request）- 指代坏请求（如，参数错误）</li>
<li>404 （not found）- 资源不存在</li>
<li>406 （not acceptable）- 服务端不支持所需表示</li>
<li>500 （internal server error）- 通用错误响应</li>
<li>503 （Service Unavailable）- 服务端当前无法处理请求</li>
</ul>
<p>　　<strong>POST</strong></p>
<ul>
<li>不安全且不幂等</li>
<li>使用服务端管理的（自动产生）的实例号创建资源</li>
<li>创建子资源</li>
<li>部分更新资源</li>
<li>如果没有被修改，则不过更新资源（乐观锁）</li>
</ul>
<ul>
<li>200（OK）- 如果现有资源已被更改</li>
</ul>
<ul>
<li>201（created）- 如果新资源被创建</li>
<li>202（accepted）- 已接受处理请求但尚未完成（异步处理）</li>
<li>301（Moved Permanently）- 资源的URI被更新</li>
<li>303（See Other）- 其他（如，负载均衡）</li>
<li>400（bad request）- 指代坏请求</li>
<li>404 （not found）- 资源不存在</li>
<li>406 （not acceptable）- 服务端不支持所需表示</li>
<li>409 （conflict）- 通用冲突</li>
<li>412 （Precondition Failed）- 前置条件失败（如执行条件更新时的冲突）</li>
<li>415 （unsupported media type）- 接受到的表示不受支持</li>
<li>500 （internal server error）- 通用错误响应</li>
<li>503 （Service Unavailable）- 服务当前无法处理请求</li>
</ul>
<p>　　<strong>PUT</strong></p>
<ul>
<li>不安全但幂等</li>
<li>用客户端管理的实例号创建一个资源</li>
<li>通过替换的方式更新资源</li>
<li>如果未被修改，则更新资源（乐观锁）</li>
</ul>
<ul>
<li>200 （OK）- 如果已存在资源被更改</li>
</ul>
<ul>
<li>201 （created）- 如果新资源被创建</li>
<li>301（Moved Permanently）- 资源的URI已更改</li>
<li>303 （See Other）- 其他（如，负载均衡）</li>
<li>400 （bad request）- 指代坏请求</li>
<li>404 （not found）- 资源不存在</li>
<li>406 （not acceptable）- 服务端不支持所需表示</li>
<li>409 （conflict）- 通用冲突</li>
<li>412 （Precondition Failed）- 前置条件失败（如执行条件更新时的冲突）</li>
<li>415 （unsupported media type）- 接受到的表示不受支持</li>
<li>500 （internal server error）- 通用错误响应</li>
<li>503 （Service Unavailable）- 服务当前无法处理请求</li>
</ul>
<p>　　<strong>DELETE</strong></p>
<ul>
<li>不安全但幂等</li>
<li>删除资源</li>
</ul>
<ul>
<li>200 （OK）- 资源已被删除</li>
</ul>
<ul>
<li>301 （Moved Permanently）- 资源的URI已更改</li>
<li>303 （See Other）- 其他，如负载均衡</li>
<li>400 （bad request）- 指代坏请求</li>
<li>404 （not found）- 资源不存在</li>
<li>409 （conflict）- 通用冲突</li>
<li>500 （internal server error）- 通用错误响应</li>
<li>503 （Service Unavailable）- 服务端当前无法处理请求</li>
</ul>
<p>　　下面我们来看一些实践中常见的问题:</p>
<ul>
<li>POST和PUT用于创建资源时有什么区别?</li>
</ul>
<p>　　POST和PUT在创建资源的区别在于，所创建的资源的名称(URI)是否由客户端决定。 例如为我的博文增加一个java的分类，生成的路径就是分类名/categories/java，那么就可以采用PUT方法。不过很多人直接把POST、GET、PUT、DELETE直接对应上CRUD，例如在一个典型的rails实现的RESTful应用中就是这么做的。 我认为，这是因为rails默认使用服务端生成的ID作为URI的缘故，而不少人就是通过rails实践REST的，所以很容易造成这种误解。</p>
<ul>
<li>客户端不一定都支持这些HTTP方法吧?</li>
</ul>
<p>　　的确有这种情况，特别是一些比较古老的基于浏览器的客户端，只能支持GET和POST两种方法。 在实践上，客户端和服务端都可能需要做一些妥协。例如rails框架就支持通过隐藏参数_method=DELETE来传递真实的请求方法， 而像Backbone这样的客户端MVC框架则允许传递_method传输和设置X-HTTP-Method-Override头来规避这个问题。</p>
<ul>
<li>统一接口是否意味着不能扩展带特殊语义的方法?</li>
</ul>
<p>　　统一接口并不阻止你扩展方法，只要方法对资源的操作有着具体的、可识别的语义即可，并能够保持整个接口的统一性。 像WebDAV就对HTTP方法进行了扩展，增加了LOCK、UPLOCK等方法。而github的API则支持使用PATCH方法来进行issue的更新，例如:</p>
<p>　　PATCH /repos/:owner/:repo/issues/:number</p>
<p>　　不过，需要注意的是，像PATCH这种不是HTTP标准方法的，服务端需要考虑客户端是否能够支持的问题。</p>
<ul>
<li>统一资源接口对URI有什么指导意义?</li>
</ul>
<p>　　统一资源接口要求使用标准的HTTP方法对资源进行操作，所以URI只应该来表示资源的名称，而不应该包括资源的操作。 通俗来说，URI不应该使用动作来描述。例如，下面是一些不符合统一接口要求的URI:</p>
<ul>
<li>GET /getUser/1</li>
<li>POST /createUser</li>
<li>PUT /updateUser/1</li>
<li>DELETE /deleteUser/1</li>
</ul>
<p>　　如果GET请求增加计数器，这是否违反安全性?</p>
<p>　　安全性不代表请求不产生副作用，例如像很多API开发平台，都对请求流量做限制。像github，就会限制没有认证的请求每小时只能请求60次。 但客户端不是为了追求副作用而发出这些GET或HEAD请求的，产生副作用是服务端“自作主张”的。 另外，服务端在设计时，也不应该让副作用太大，因为客户端认为这些请求是不会产生副作用的。</p>
<ul>
<li>直接忽视缓存可取吗?</li>
</ul>
<p>　　即使你按各个动词的原本意图来使用它们，你仍可以轻易禁止缓存机制。 最简单的做法就是在你的HTTP响应里增加这样一个报头： Cache-control: no-cache。 但是，同时你也对失去了高效的缓存与再验证的支持(使用Etag等机制)。 对于客户端来说，在为一个REST式服务实现程序客户端时，也应该充分利用现有的缓存机制，以免每次都重新获取表示。</p>
<ul>
<li>响应代码的处理有必要吗?</li>
</ul>
<p>　　HTTP的响应代码可用于应付不同场合，正确使用这些状态代码意味着客户端与服务器可以在一个具备较丰富语义的层次上进行沟通。 例如，201（“Created”）响应代码表明已经创建了一个新的资源，其URI在Location响应报头里。 假如你不利用HTTP状态代码丰富的应用语义，那么你将错失提高重用性、增强互操作性和提升松耦合性的机会。 如果这些所谓的RESTful应用必须通过响应实体才能给出错误信息，那么SOAP就是这样的了，它就能够满足了。</p>
<p>　　<strong>2. 3 资源的表述</strong></p>
<p>　　上面提到，客户端通过HTTP方法可以获取资源，是吧? 不，确切的说，客户端获取的只是资源的表述而已。 资源在外界的具体呈现，可以有多种表述(或成为表现、表示)形式，在客户端和服务端之间传送的也是资源的表述，而不是资源本身。 例如文本资源可以采用html、xml、json等格式，图片可以使用PNG或JPG展现出来。 资源的表述包括数据和描述数据的元数据，例如，HTTP头“Content-Type” 就是这样一个元数据属性。</p>
<p>　　那么客户端如何知道服务端提供哪种表述形式呢?</p>
<p>　　答案是可以通过HTTP内容协商，客户端可以通过Accept头请求一种特定格式的表述，服务端则通过Content-Type告诉客户端资源的表述形式。</p>
<p>　　以github为例，请求某组织资源的json格式的表述形式:</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19mY2M0YzEzNThhZTkxMTEzM2I4NDZjNWI4ZWU1OGU5NC5qcGc=.jpg"></p>
<p>　　假如github也能够支持xml格式的表述格式，那么结果就是这样的:</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19lZmNjZDA2ZjY1MTE3NWRlNDkzODM3YTMxMGZkMzkxZS5qcGc=.jpg"></p>
<p>　　下面我们来看一些实践上常见的设计:</p>
<p>　　<strong>在URI里边带上版本号</strong></p>
<p>　　有些API在URI里边带上版本号，例如:</p>
<ul>
<li>http://api.example.com/1.0/foo</li>
<li>http://api.example.com/1.2/foo</li>
<li>http://api.example.com/2.0/foo</li>
</ul>
<p>　　如果我们把版本号理解成资源的不同表述形式的话，就应该只是用一个URL，并通过Accept头部来区分，还是以github为例，它的Accept的完整格式是:application/vnd.github[.version].param[+json]</p>
<p>　　对于v3版本的话，就是Accept: application/vnd.github.v3。对于上面的例子，同理可以使用使用下面的头部:</p>
<ul>
<li>Accept: vnd.example-com.foo+json; version=1.0</li>
<li>Accept: vnd.example-com.foo+json; version=1.2</li>
<li>Accept: vnd.example-com.foo+json; version=2.0</li>
</ul>
<p>　　<strong>使用URI后缀来区分表述格式</strong></p>
<p>　　像rails框架，就支持使用/users.xml或/users.json来区分不同的格式。 这样的方式对于客户端来说，无疑是更为直观，但混淆了资源的名称和资源的表述形式。 我个人认为，还是应该优先使用内容协商来区分表述格式。</p>
<p>　　<strong>如何处理不支持的表述格式</strong></p>
<p>　　当服务器不支持所请求的表述格式，那么应该怎么办？若服务器不支持，它应该返回一个HTTP 406响应，表示拒绝处理该请求。下面以github为例，展示了一个请求XML表述资源的结果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19mMzg0ZDA2Mjc4NDQwODNlMzI4ODBjYTI5ZDRiMjIxMy5qcGc=.jpg"></p>
<p>　　<strong>2. 4 资源的链接</strong></p>
<p>　　我们知道REST是使用标准的HTTP方法来操作资源的，但仅仅因此就理解成带CURD的Web数据库架构就太过于简单了。 这种反模式忽略了一个核心概念：“超媒体即应用状态引擎（hypermedia as the engine of application state）”。 超媒体是什么? 当你浏览Web网页时，从一个连接跳到一个页面，再从另一个连接跳到另外一个页面，就是利用了超媒体的概念：把一个个把资源链接起来.</p>
<p>　　要达到这个目的，就要求在表述格式里边加入链接来引导客户端。在《RESTful Web Services》一书中，作者把这种具有链接的特性成为连通性。下面我们具体来看一些例子。</p>
<p>　　下面展示的是github获取某个组织下的项目列表的请求，可以看到在响应头里边增加Link头告诉客户端怎么访问下一页和最后一页的记录。 而在响应体里边，用url来链接项目所有者和项目地址。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19lODYzMjVkOWU1ODQxNGVhMTk4MGNiZTczYTM5YWY1Ni5qcGc=.jpg"></p>
<p>　　又例如下面这个例子，创建订单后通过链接引导客户端如何去付款。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hYWQxOTc5ZjliMmExYzFlNTNjNjBlOGMxN2M2NWVkZC5qcGc=.jpg"></p>
<p>　　上面的例子展示了如何使用超媒体来增强资源的连通性。很多人在设计RESTful架构时，使用很多时间来寻找漂亮的URI，而忽略了超媒体。所以，应该多花一些时间来给资源的表述提供链接，而不是专注于“资源的CRUD”。</p>
<p>　　<strong>2. 5 状态的转移</strong></p>
<p>　　有了上面的铺垫，再讨论REST里边的状态转移就会很容易理解了。 不过，我们先来讨论一下REST原则中的无状态通信原则。初看一下，好像自相矛盾了，既然无状态，何来状态转移一说?</p>
<p>　　其实，这里说的无状态通信原则，并不是说客户端应用不能有状态，而是指服务端不应该保存客户端状态。</p>
<p>　　<strong>2. 5.1 应用状态与资源状态</strong></p>
<p>　　实际上，状态应该区分应用状态和资源状态，客户端负责维护应用状态，而服务端维护资源状态。 客户端与服务端的交互必须是无状态的，并在每一次请求中包含处理该请求所需的一切信息。 服务端不需要在请求间保留应用状态，只有在接受到实际请求的时候，服务端才会关注应用状态。 这种无状态通信原则，使得服务端和中介能够理解独立的请求和响应。 在多次请求中，同一客户端也不再需要依赖于同一服务器，方便实现高可扩展和高可用性的服务端。</p>
<p>　　但有时候我们会做出违反无状态通信原则的设计，例如利用Cookie跟踪某个服务端会话状态，常见的像J2EE里边的JSESSIONID。 这意味着，浏览器随各次请求发出去的Cookie是被用于构建会话状态的。 当然，如果Cookie保存的是一些服务器不依赖于会话状态即可验证的信息（比如认证令牌），这样的Cookie也是符合REST原则的。</p>
<p>　　<strong>2. 5.2 应用状态的转移</strong></p>
<p>　　状态转移到这里已经很好理解了， “会话”状态不是作为资源状态保存在服务端的，而是被客户端作为应用状态进行跟踪的。客户端应用状态在服务端提供的超媒体的指引下发生变迁。服务端通过超媒体告诉客户端当前状态有哪些后续状态可以进入。 这些类似“下一页”之类的链接起的就是这种推进状态的作用——指引你如何从当前状态进入下一个可能的状态。</p>
<p>　　<strong>3. 总结</strong></p>
<p>　　现在广东XXX版本、XXX等项目中均使用传统的RPC、SOAP方式的Web服务，而移动南方基地XXXX项目的后台， 虽然采用了JSON格式进行交互，但还是属于RPC风格的。本文从资源的定义、获取、表述、关联、状态变迁等角度， 试图快速理解RESTful架构背后的概念。RESTful架构与传统的RPC、SOAP等方式在理念上有很大的不同，希望本文能对各位理解REST有所帮助。</p>
<p> </p>
<p>http://kb.cnblogs.com/page/512047/</p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 07:57:00</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9e%b6%e6%9e%84/" title="架构">架构</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/https/" title="HTTPS">HTTPS</a>, <a href="https://www.iamivan.net/tag/http/" title="http">http</a>, <a href="https://www.iamivan.net/tag/%e8%b4%9f%e8%bd%bd%e5%9d%87%e8%a1%a1/" title="负载均衡">负载均衡</a>, <a href="https://www.iamivan.net/tag/github/" title="github">github</a>, <a href="https://www.iamivan.net/tag/rest/" title="REST">REST</a>, <a href="https://www.iamivan.net/tag/git/" title="git">git</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>RESTful架构详解（转）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlBa7az.html" rel="bookmark">揭开面纱：Kubernetes架构详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[编者的话] 本文介绍了Kubernetes中的主要组件和各个组件的工作模式. 入门导论:Kubernetes组件和组件之间如何协同工作 本文讲的是揭开面纱:Kubernetes架构详解如果你正在实现容器的落地,你需要一个容器管理平台.假如你正在阅读本文,那你很有可能已经考虑了Kubernetes的优势. 什么是Kuberbetes?这个异常火爆的容器编排引擎的内在到底是些什么?它们如何一同为处理生产环境中的容器化应用提供一个面向未来的.可靠的.可伸缩的潜在方案?(请注意这里故意使用了&quot;潜在&q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My3ZvZz.html" rel="bookmark">三层架构详解（服务员-厨师-采购员）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				三层架构详解 1,什么是三层? 2,为什么使用三层? 3,三层与以往使用的两层相比有什么不同?它的优势在哪里? 4,如何学好三层?如何应用三层? -- 对于三层我左思右想,如何与实际相联系.好嘛,昨晚突然有了&quot;灵感&quot;.还记得大话设计模式里第23章大鸟和小菜吃羊肉串的故事--由在小摊吃到饭店吃引来的一个命令模式(当然今天不是研究命令模式).服务员.厨师.采购员. 这不就是个典型的三层架构吗???(⊙ o ⊙ )啊!哈哈(这个后面再做解释)     先了解:   1,什么是三层? UI(表			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze6J18b.html" rel="bookmark">【独家】老庙黄金2016春晚抢红包活动技术架构详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[编者按]2016春晚红包技术实践系列选题来了!阿里云有一支特殊的团队--护航团队.从最初的12306到现在的红包,每一个备受关注的项目背后都有他们的身影.今年护航团队由支付宝.阿里云和其他技术伙伴组成.本文来自驻云科技COO兼首席架构师肖凯的纯干货分享,欢迎交流反馈.   肖凯 驻云科技COO兼首席架构师 云计算技术践行者,曾帮助新华社.陌陌.航天信息等数百家企业完成上云,曾就职于IBM.EMC等外企,对企业互联网化转型及企业IT架构有深刻理解,坚信公有云才是企业IT的未来. 下为正文: 抢红			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6NgVXM.html" rel="bookmark">100&percnt;移植阿里云移动测试技术，竟仅需1周？！&mdash;&mdash;移动测试专有云（2）&mdash;&mdash;架构详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				移动测试的应用架构 作为一整个庞大的移动测试解决方案,MQC专有云系统内部包含了非常多的软硬件模块,整个系统紧密高效的互相连接稳定配合.从模块划分上来看,主要包括:用户交互平台.任务调度平台.移动终端控制系统.无线机房管理平台.自动化测试能力.中间件(数据库.缓存.文件存储).无线机房硬件方案.专家支持服务.除了自动化测试能力,其他应用模块构成专有云基础服务. 专有云基础服务是专有云解决方案必须包含的一整套软硬件方案,是整个专有云系统的软硬件基础.基础服务里包含几个重要平台:用户交互平台.任务调			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQlaqp.html" rel="bookmark">女娲：阿里云分布式一致性协同服务架构详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				他的演讲内容主要分为四个方面:分布式协同服务背景.女娲服务架构以及技术演进.典型女娲服务应用场景分享.全球化架构下的女娲进化,下面是本次分享内容整理.点击查看回顾视频 分布式协同服务背景 分布式协同服务 在大规模云计算场景中,为保障数据分布式一致性,数量众多的计算节点往往依赖分布式协同服务来同步对共享资源的互斥访问,或者依赖分布式协同服务的消息通知功能来协调各自之间动作,使众多节点作为一个整体完成一项工作. 作为云计算分布式系统的核心,在设计分布式协同服务之初需要考虑互斥性.消息通知和扩展性三个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWNGPnb.html" rel="bookmark">【DUBBO】dubbo架构详解（转载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载地址:http://shiyanjun.cn/archives/325.html Dubbo是Alibaba开源的分布式服务框架,它最大的特点是按照分层的方式来架构,使用这种方式可以使各个层之间解耦合(或者最大限度地松耦 合).从服务模型的角度来看,Dubbo采用的是一种非常简单的模型,要么是提供方提供服务,要么是消费方消费服务,所以基于这一点可以抽象出服务提供方 (Provider)和服务消费方(Consumer)两个角色.关于注册中心.协议支持.服务监控等内容,详见后面描述. 总体架构			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ybjlW5p.html" rel="bookmark">Linux目录架构详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux和Windows操作系统的显著区别之一就是目录架构的不同.Linux操作系统的目录架构遵循文件系统层级结构标准.不知你是否使用ls命令浏览过Linux的根目录&quot;/&quot;,亲爱的读者,您都了解这些目录的含义吗? ls -l / 遍历文件系统(点击看大图) 本文将引领您浏览Linux的目录架构,并解释每个重要目录的含义. / - Root 通常称为根分区.所有的文件和目录皆由此开始.只有root用户对此目录拥有写权限. /bin - 用户可执行文件 此目录包含二进制可执行文件.在单用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2RRqQb.html" rel="bookmark">DRBD架构详解&lpar;原创&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				DRBD概述Distributed Replicated Block Device(DRBD)是一种基于软件的,无共享,复制的存储解决方案,在服务器之间的对块设备(硬盘,分区,逻辑卷等)进行镜像.DRBD工作在内核 当中的,类似于一种驱动模块.DRBD工作的位置在文件系统的buffer cache和磁盘调度器之间,通过tcp/ip发给另外一台主机到对方的tcp/ip最终发送给对方的drbd,再由对方的drbd存储在本地对应磁盘 上,类似于一个网络RAID-1功能.在高可用(HA)中使用DRBD功			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlLRdRM.html" rel="bookmark">老庙黄金2016春晚抢红包活动技术架构详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				抢红包.秒杀等营销手段现在越来越流行了,而这种活动却带给IT攻城狮们巨大的挑战.抢红包系统从前端看起来都是很简单的,但实际上对应的后端系统却非常复杂,因为瞬时高并发所带来的问题将整个系统架构的复杂度提升了几个数量级. 笔者所在的驻云科技就参与了春晚支付宝老庙黄金新春抢红包活动系统的建设和护航工作.在这里跟大家做个分享,一起探讨如何利用云计算技术来在短时间内构建强大且具备灵活扩展性的架构. 一. 架构需求调研 抢红包系统的逻辑一般都比较简单,用户在一个页面上点击,加上简单的交互,将请求发送至服务端			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbaaDQb.html" rel="bookmark" class="title">PS经典合成魔法森林中的小公主</a>
					<div>
						效果图有点复杂,用到的素材较多.学习的时候重点掌握作者的溶图方法,如何把想要的素材快速添加到画面里面,并完美融入画面. 最终效果 1.打开Ps,新建文件,按照下图所示设置. 2.现在置入背景文件. 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmAGjp.html" rel="bookmark" class="title">进入主页以后自动播放声音</a>
					<div>
						进入主页以后自动播放声音 [Ctrl+A 全部选择 提示:你可先修改部分代码,再按运行]					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKZKZz.html" rel="bookmark" class="title">将IP地址转换为长整型、将长整型转换为IP地址</a>
					<div>
						ip地址|转换 将IP地址转换为长整型 Converts a string ip address (&quot;192.168.0.1&quot;) to a Long number (3232235 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMq5YKM.html" rel="bookmark" class="title">ASP 中利用OWC 服务器端组件动态生成图表</a>
					<div>
						动态|服务器|图表 引:Web程序开发中,经常需要从数据库表文件中提取数据,并对大批量的数据进行分析比较,此时最常用也是最直观明了的表现方法莫过于绘制图表. ASP擅长服务器端的Web编程,操作后台数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZOKeob.html" rel="bookmark" class="title">设计范式</a>
					<div>
						本章要向大家介绍重要但却并不是那么传统的&quot;范式&quot;(Pattern)程序设计方法. 在向面向对象程序设计的演化过程中,或许最重要的一步就是&quot;设计范式&quot;(Desig ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balNV2z.html" rel="bookmark" class="title">在Applet中引用jar中的资源文件的方法</a>
					<div>
						如果想要做一个比较漂亮的Applet让人家使用,一定会加上很多资源,比如图片或者声音文件什么的. sun提供了一个有用的工具,jar.这个工具可以把这些资源文件合在一个文件里,避免频繁的http re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ya3kz.html" rel="bookmark" class="title">阿里云相关协议有哪些</a>
					<div>
						云服务器服务(ECS)服务条款 申请续用Windows Server 2003 镜像服务协议 API使用规范 云服务器(ECS)服务等级协议(SLA) 云服务器服务保障 快照免费试用服务条款					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1k0jz.html" rel="bookmark" class="title">thinkPHP学习笔记之安装配置篇</a>
					<div>
						 这篇文章主要介绍了一款国产MVC框架thinkPHP,这里讲诉的是thinkphp的安装与配置,以及一个简单实例,有需要的小伙伴可以参考下.     国产框架thinkPHP,是一款MVC框架,这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1LYGz.html" rel="bookmark" class="title">设置IIS网站独立帐号确保服务器安全</a>
					<div>
						被人黑过站的同学,都应该有这样的经历.自己的服务器某个站被人入侵后,其它的网站也相继遭殃,这是啥情况呢?百分之九十是IIS网站帐号权限过大,服务器上的所有网站共用一个IIS帐号所致,接来下新手如何设置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWdQop.html" rel="bookmark" class="title">Win8&period;1 Update RTM版本更新后怎样恢复到之前的系统</a>
					<div>
						  相信很多用户会通过windows Update更新功能或其他渠道来升级系统,比如说win7 64位旗舰版.在更新Win8.1 Update RTM版本后发现win8.1系统只是增加部分功能而已,不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaG6RM.html" rel="bookmark" class="title">Win7系统笔记本的五个设置小技巧</a>
					<div>
						  1.让Windows7节能下载 虽然如今的宽带比以前快很多,但相比庞大的高清电影以及大型程序来讲还是捉襟见肘,于是很多网友都喜欢在下班前或临睡前设好下载工具,让电脑继续下载.虽 然此刻电脑只是在执 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRoAVp.html" rel="bookmark" class="title">《从零开始学Swift》学习笔记（Day 63）&mdash;&mdash;Cocoa Touch设计模式及应用之单例模式</a>
					<div>
						原创文章,欢迎转载.转载请注明:关东升的博客   什么是设计模式.设计模式是在特定场景下对特定问题的解决方案,这些解决方案是经过反复论证和测试总结出来的.实际上,除了软件设计,设计模式也被广泛应用于其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQjZVp.html" rel="bookmark" class="title">创始人CEO该拿多少工资？</a>
					<div>
						创始人CEO这个头衔很帅吗?但着实是苦逼的干活.今天我们来看下一个初创公司的创始人CEO一般来说该给自己开多少工资. 美国媒体曾经针对美国创业公司做过一项调查,结果显示:美国初创公司的创始人的现金工资 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PLqQp.html" rel="bookmark" class="title">一次linux救援模式修复</a>
					<div>
						环境描述: 系统版本:CentOS 6.5 64 故障描述: /bin/sh目录文件缺失,导致CentOS启动卡条: 排查过程: 昨天晚上接到小伙伴反馈他们的yum源服务器重启之后无响应,遂登录Vce ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mydw8kb.html" rel="bookmark" class="title">Photoshop山林外拍的人物加上秋季暗黄色霞光</a>
					<div>
						  Photoshop山林外拍的人物加上秋季暗黄色霞光            素材图片天空都是白色的,与底部的树林颜色落差太大.处理的时候可以把白色天空换上霞光素材,然后把图片主色转为暖色,并渲染好高 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydZNdb.html" rel="bookmark" class="title">上海普陀区征集武宁科技园规划方案</a>
					<div>
						商报记者 袁晨晨 为优化和完善武宁科技园产业布局和结构,有效发掘.激活.整合武宁科技园现有科技资源,普陀区逐步拓展了以低压电器.智能电器设计和测绘等行业为主的产业链. 为达到凸显园区的产业特色.提升园 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlK49Rb.html" rel="bookmark" class="title">回顾2016年大数据的发展，盘点十大最热门的数据岗位</a>
					<div>
						随着很多大公司对数据分析需求增多,数据相关岗位的人才需求量也越来越大.数据学作为一门学科,已经受到时代的追捧.数据学,或者更准确来说,大数据,在2000年早期还是个冷门,而现在早已成为人们关注的焦点. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYJK5p.html" rel="bookmark" class="title">小侃北京IT从业者，其实我们还不如蹬三轮的</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 北京的互联网环境是最好的, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXRLxz.html" rel="bookmark" class="title">SqlServer基础--Select &ast;与Select 指定列的区别</a>
					<div>
						select * from table 有聚集索引:聚集索引扫描 没有聚集索引 :表扫描 select 所有的列名 from talbe 有聚集索引:聚集索引扫描 没有聚集索引 :表扫描 select ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7Lekz.html" rel="bookmark" class="title">车联网将颠覆整个车险生态圈</a>
					<div>
						&quot;车联网将颠覆整个车险生态圈.&quot;正是这个信念,驱使着赵强(化名)毅然告别大型保险公司车险部精算主管的职位,创立一家车联网公司,专门为保险公司设计研发基于车联网的车险创新产品. 在他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7xYvKb.html" rel="bookmark" class="title">继承-java 子类构造函数要用到父类的方法判断成功后再构造，但这样的话super&lpar;&rpar;不是第一句就报错</a>
					<div>
						问题描述 java 子类构造函数要用到父类的方法判断成功后再构造,但这样的话super()不是第一句就报错 父类是点,里面有方法判断是不是同一个点,子类是直线,我在子类直线构造时要判断两个点是否相等, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJGlmp.html" rel="bookmark" class="title">在TextBox输入数据口&period;点了按钮以后&period;为什么文本框中的数据还在&period;</a>
					<div>
						问题描述 在TextBox输入数据口.点了按钮以后.为什么文本框中的数据还在.已经把TextBox中EnableViewState属性改为False 解决方案 解决方案二:为什么不用TextBox1. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEoEGp.html" rel="bookmark" class="title">《教孩子学编程（Python语言版）》&mdash;&mdash;导读</a>
					<div>
						前 言 什么是编程,为什么编程很适合孩子 计算机编程是每个孩子都应该学习的一项重要技能.我们使用计算机解决问题,玩游戏,帮助我们更有效地工作,执行重复性的任务,存储和查找信息,创建新的内容,同时与我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Nlmop.html" rel="bookmark" class="title">hibernate show&lowbar;sql 问题</a>
					<div>
						问题描述 hibernate show_sql 问题 如下后台打印的语句,我的表是sys_user 为何他要写成sysuser0_.id,后面的as id1_58 又是什么意思,有没有这样的文章让我学 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0N6g7z.html" rel="bookmark" class="title">android帮助文档打开慢的三种解决方法&lowbar;Android</a>
					<div>
						经查是因为本地文档中的网页有如下js代码会联网加载信息,将其注释掉后就好了 复制代码 代码如下: &lt;script src=&quot;http://www.google.com/jsapi&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLgaDM.html" rel="bookmark" class="title">工作10几年的dba总结的sql查询语句优化</a>
					<div>
						目录 1.什么是执行计划?执行计划是依赖于什么信息. 2. 统一SQL语句的写法减少解析开销 3. 减少SQL语句的嵌套 4. 使用&quot;临时表&quot;暂存中间结果 5. OLTP系统SQL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXdePjp.html" rel="bookmark" class="title">英语八级考题泄露 帖子已被百度删除</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 百度专八吧上的一个帖子让北京某高校 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5YgO6p.html" rel="bookmark" class="title">IT与&OpenCurlyDoubleQuote;挨踢&rdquo;</a>
					<div>
						IT作为http://www.aliyun.com/zixun/aggregation/14054.html&quot;&gt;信息技术的专业词汇,早已是家喻户晓了.可是,我们在拥有渊博的IT知识,实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNma37b.html" rel="bookmark" class="title">10分钟23张图，带你了解中国互联网现状</a>
					<div>
						文章讲的是10分钟23张图,带你了解中国互联网现状,7月23日,中国互联网络信息中心(CNNIC)发布&lt;第36次中国互联网络发展状况统计报告&gt;.CNNIC报告起始于1997年,每半年发布一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK0oYZM.html" rel="bookmark" class="title">《Adobe InDesign CS5中文版经典教程》&mdash;第1课1&period;5节修改文档的缩放比例</a>
					<div>
						1.5 修改文档的缩放比例Adobe InDesign CS5中文版经典教程InDesign中的控件让用户能够以5%到4000%的比例查看文档.文档打开后,当前的缩放比例显示在应用程序栏(控制面板上方 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.035 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
